package com.diagbot.facade;

import com.diagbot.biz.push.entity.Item;
import com.diagbot.dto.HighRiskNeoDTO;
import com.diagbot.dto.IndicationDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.process.HighRiskProcess;
import com.diagbot.vo.HighRiskNeoVO;
import com.diagbot.vo.IndicationPushVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @Description: 高风险合理性facade
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class HighRiskFacade {

    @Autowired
    NeoFacade neoFacade;
    @Autowired
    HighRiskProcess highRiskProcess;
    @Autowired
    CommonFacade commonFacade;

    /**
     * 高风险提示
     * @param
     * @return
     */
    public void highRiskFac(IndicationPushVO indicationPushVO, WordCrfDTO wordCrfDTO, IndicationDTO res) {
        // 高风险图谱接口调用
        HighRiskNeoVO highRiskNeoVO = fillHighRiskNeo(wordCrfDTO);
        List<HighRiskNeoDTO> highRiskNeoDTOList = neoFacade.getHighRiskNeo(highRiskNeoVO);
        // TODO 测试数据开始
//        List<HighRiskNeoDTO> highRiskNeoDTOList = new ArrayList<>();
        HighRiskNeoDTO highRiskNeoDTO = new HighRiskNeoDTO();
        highRiskNeoDTO.setName("安眠药");
        highRiskNeoDTO.setStandname("安眠药");
        highRiskNeoDTO.setType("药品");
        highRiskNeoDTOList.add(highRiskNeoDTO);

        HighRiskNeoDTO highRiskNeoDTO2 = new HighRiskNeoDTO();
        highRiskNeoDTO2.setName("切除手术");
        highRiskNeoDTO2.setStandname("切除手术");
        highRiskNeoDTO2.setType("手术");
        highRiskNeoDTOList.add(highRiskNeoDTO2);
        // TODO 测试数据结束

        // 规则处理
        highRiskProcess.process(highRiskNeoDTOList, res);
    }


    public HighRiskNeoVO fillHighRiskNeo(WordCrfDTO wordCrfDTO) {
        HighRiskNeoVO highRiskNeoVO = new HighRiskNeoVO();

        List<Item> items = wordCrfDTO.getDrugOrder();

        for (Item item : items) {
            highRiskNeoVO.getDrugList().put(item.getName(), item.getUniqueName());
        }

        items = wordCrfDTO.getOperationOrder();

        for (Item item : items) {
            highRiskNeoVO.getOperationList().put(item.getName(), item.getUniqueName());
        }


        return highRiskNeoVO;
    }
}
